import { IValidation } from '../Patterns/Validator/IValidation';
import { Model } from './Model';
import { InputTypes } from './inputTypes';
export declare function Label(label: string): (target: Model<unknown>, key: string) => void;
export declare function Description(description: string): (target: Model<unknown>, key: string) => void;
export declare function InputType(inputType: InputTypes): (target: Model<unknown>, key: string) => void;
export declare function Validations<T>(validations: Array<IValidation<Model<T>>>): (target: Model<T>, key: string) => void;
export declare function Options<T>(options: Record<string, string>, customErrorMessage?: string): (target: Model<T>, key: string) => void;
export declare function Required<T>(customErrorMessage?: string): (target: Model<T>, key: string) => void;
export declare function Range<T>(minimum: number, maximum: number, customErrorMessage?: string): (target: Model<T>, key: string) => void;
export declare function StringLength<T>(minimum: number, maximum: number, customErrorMessage?: string): (target: Model<T>, key: string) => void;
export declare function RegExp<T>(regex: RegExp, customErrorMessage?: string): (target: Model<T>, key: string) => void;
