import { IGenericStorage } from './IGenericStorage';
import { JsonSerializer } from '../../Utility/Serialization/JsonSerializer';
import { Result } from '../../Patterns/Result/Result';
export declare enum DomStorageMode {
    Session = 0,
    Local = 1
}
/**
 * Provides a generic interface for interacting with DomStorage
 */
export declare class DomStorage implements IGenericStorage {
    private storageMode;
    private serializer;
    constructor(storageMode: DomStorageMode, serializer?: JsonSerializer);
    Get<T>(type: {
        new (): T;
    }, key: string): Result<T | null>;
    Set<T>(key: string, value: T): Result<null>;
    GetValue(key: string): Result<string | null>;
    SetValue(key: string, value: string): Result<null>;
    Remove(key: string): Result<null>;
    private getStorageMedium;
}
