import { Result } from '../../Patterns/Result/module';
import { IIndexedDb } from './IIndexedDb';
import { Migration } from './Migration';
export declare class IndexedDb implements IIndexedDb {
    Name: string;
    Version: number;
    private migrations;
    private indexedDbFactory;
    static Instance(name: string, version: number, migrations: Migration[], indexedDbFactory?: IDBFactory): IIndexedDb;
    private database;
    get Connected(): boolean;
    private constructor();
    Connect(): Promise<Result<IDBDatabase | null>>;
    Insert(insertions: Record<string, object[]>): Promise<Result<null>>;
    Get<T>(storeName: string, query: string | number | ((t: T) => boolean)): Promise<Result<T | T[] | null>>;
    GetAll<T>(storeName: string): Promise<Result<T[]>>;
    Delete(deletions: Record<string, string[]>): Promise<Result<null>>;
    Update(updates: Record<string, object[]>): Promise<Result<null>>;
    Disconnect(): void;
    private setOpenRequestHandlers;
    private executeTransaction;
}
