import { IPersister } from '../IPersister';
import { IPathResolver } from './IPathResolver';
import { IFileSystemAdapter } from './IFileSystemAdapter';
/**
 * Persists data using the node fs / path api
 */
export declare class FSPersister<T> implements IPersister<T> {
    private localFilesDirectory;
    private filePath;
    private key;
    private pathResolver;
    private fileSystemAdapter;
    private get dir();
    private get file();
    constructor(localFilesDirectory: string, filePath: string, key: string, pathResolver: IPathResolver, fileSystemAdapter: IFileSystemAdapter);
    Retrieve(): any[];
    Persist(items: any[]): void;
    Purge(): void;
    private ensureLocalFilesDirExists;
    private ensureFileExists;
    private writeBlankJsonToFile;
    private retrieveDataFileJson;
}
