"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Csv = void 0;
var Query_1 = require("../Patterns/CommandQuery/Query");
var Strings_1 = require("./Strings");
var Csv = /** @class */ (function () {
    function Csv() {
    }
    /**
     * Accepts a json object and returns the CSV string equivalent.
     * @param json
     */
    Csv.EncodeAsCsv = function (headers, json) {
        var _this = this;
        var csvConversionResult = new Query_1.Query(function () {
            return _this.convertToCSV(json);
        }).Execute();
        return csvConversionResult.IsSuccess && csvConversionResult.Value ?
            "".concat(headers.toString(), "\r\n").concat(csvConversionResult.Value) :
            Strings_1.Strings.Empty;
    };
    Csv.convertToCSV = function (json) {
        var array = typeof json !== 'object' ? JSON.parse(json) : json;
        var str = Strings_1.Strings.Empty;
        for (var i = 0; i < array.length; i++) {
            var line = Strings_1.Strings.Empty;
            for (var index in array[i]) {
                if (line !== Strings_1.Strings.Empty) {
                    line += ',';
                }
                var value = array[i][index];
                line += value !== Strings_1.Strings.Empty ? "\"".concat(value, "\"") : Strings_1.Strings.Empty;
            }
            str += line + '\r\n';
        }
        return str.trim();
    };
    return Csv;
}());
exports.Csv = Csv;
//# sourceMappingURL=Csv.js.map