"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormUrl = void 0;
var Strings_1 = require("./Strings");
var FormUrl = /** @class */ (function () {
    function FormUrl() {
    }
    /**
     * Returns the form url encoded string version of the given json object.
     * Intended for json consisting of string values only.
     * @param json
     */
    FormUrl.EncodeJson = function (json) {
        var formData = Strings_1.Strings.Empty;
        var keys = Object.keys(json);
        for (var i = 0; i < keys.length; i++) {
            var key = keys[i];
            formData += "".concat(key, "=").concat(json[key]).concat(i < keys.length - 1 ? '&' : Strings_1.Strings.Empty);
        }
        return formData;
    };
    /**
     * Returns the json version of the form url encoded string given.
     * @param formData
     */
    FormUrl.DecodeToJson = function (formData) {
        var json = {};
        if (formData.indexOf('=') >= 0) {
            if (formData.indexOf('&') >= 0) {
                var keyValuePairs = formData.split('&');
                keyValuePairs.forEach(function (keyValuePair) {
                    FormUrl.SetKeyValuePair(keyValuePair, json);
                });
            }
            else {
                FormUrl.SetKeyValuePair(formData, json);
            }
        }
        return json;
    };
    FormUrl.SetKeyValuePair = function (formData, json) {
        var keyValuePair = formData.split('=');
        if (keyValuePair.length >= 2) {
            json[keyValuePair[0]] = keyValuePair[1];
        }
    };
    return FormUrl;
}());
exports.FormUrl = FormUrl;
//# sourceMappingURL=FormUrl.js.map