import { ISpeechCommand } from './ISpeechCommand';
import { ISpeechRecognition } from './ISpeechRecognition';
import { ISpeechRecognizer } from './ISpeechRecognizer';
declare global {
    interface Window {
        webkitSpeechRecognition?: {
            new (): ISpeechRecognition;
        };
    }
}
export declare class SpeechRecognizer implements ISpeechRecognizer {
    private speechRecognition;
    constructor(speechRecognition?: ISpeechRecognition | null);
    Listen(): Promise<string>;
    HandleSpeechCommands(commands: ISpeechCommand[], until: () => boolean): Promise<void>;
}
